% Exercise 1.2

% Add the path to the additional m-files
addpath('functions');

% -------------------------------------------------------------------------
% Edit this part to do the exercises

% Try different values for either:
%    (1) the number of dimensions of the search space
%    (2) how close the parent is to the global optimum
%    (3) the mutation rate
% If you vary one of the three things, you may want to keep the other two
% at a constant value to better understand the effects (as shown in the
% example below).

% (1) Vary the number of dimensions of the search space
nvars_1 = 1;
nvars_2 = 10;
nvars_3 = 100;

% (2) Vary how close the parent is to the optimum
value_1 = 1;
value_2 = 1;
value_3 = 1;

% The parents are created for the three conditions
x0_1 = value_1*ones(nvars_1, 1);
x0_2 = value_2*ones(nvars_2, 1);
x0_3 = value_3*ones(nvars_3, 1);

% (3) Vary the standard deviation of the Gaussian mutations
stdev_1 = 1;
stdev_2 = 1;
stdev_3 = 1;

% Number of offspring to be generated
numOffspring = 200;

% -------------------------------------------------------------------------

% Generate offspring for the three conditions
[parentFitness_1 offspringFitness_1] = generateOffspring(x0_1, stdev_1, numOffspring, 0);
[parentFitness_2 offspringFitness_2] = generateOffspring(x0_2, stdev_2, numOffspring, 0);
[parentFitness_3 offspringFitness_3] = generateOffspring(x0_3, stdev_3, numOffspring, 0);

% Boxplot of the offspring fitnesses. The fitness of the parent is plotted as
% a dashed, green line.
figure;
hold on;
boxplot([offspringFitness_1 offspringFitness_2 offspringFitness_3], 'notch', 'on');

plot([0.5 1.5], [parentFitness_1 parentFitness_1], 'g--');
plot([1.5 2.5], [parentFitness_2 parentFitness_2], 'g--');
plot([2.5 3.5], [parentFitness_3 parentFitness_3], 'g--');
ylabel Fitness;
xlabel('');
ylim_ = ylim;
ylim([0 ylim_(2)]);
