% Exercise 2.2

% Add the path to the additional m-files
addpath('functions');
    
% -------------------------------------------------------------------------
% Edit this part to do the exercises

nvars = 2; % Number of dimensions of the search space
stdev = [0.01 0.1 1]; % Standard deviation of the Gaussian mutations
numGenerations = 50; % Number of generations of the GA
numRuns = 10; % Number of runs to be done for each stdev

% -------------------------------------------------------------------------

crossover = 0; % Crossover fraction
tournamentSize = 2; % Tournament size
popSize = 20; % Population size
popInitRange = [-10; 10]; % Range for the initial population
display = 0; % Plot initial and final populations

% Reserve space to save the best fitness of each run and for each condition
bestFitnesses = zeros(numRuns, length(stdev));

% Run the GAs
for i = 1:length(stdev)
    for j = 1:numRuns
        [bestInd bestFit] = runGA(@fsphere, nvars, stdev(i), crossover, tournamentSize, popSize, popInitRange, numGenerations, display);
        bestFitnesses(j,i) = bestFit;
    end
end

% Boxplot comparing the best fitnesses
figure;
boxplot(bestFitnesses, 'notch', 'on');
set(gca, 'YScale', 'log');
ylabel('Best fitness');
