% Exercise 3.2

% Add the path to the additional m-files
addpath('functions');
    
% -------------------------------------------------------------------------
% Edit this part to do the exercises

crossover = [0 0.25 0.5]; % Crossover fraction

% -------------------------------------------------------------------------

nvars = 10; % Number of dimensions of the search space
stdev = 0.5; % Standard deviation of the Gaussian mutations
tournamentSize = 2; % Tournament size
popSize = 20; % Population size
popInitRange = [-10; 10]; % Range for the initial population
numGenerations = 50; % Number of generations of the GA
numRuns = 5; % Number of runs to be done for each crossover fraction
display = 1; % Plot initial and final populations

% Reserve space to save the best fitness of each run and for each condition
bestFitnesses = zeros(numRuns, length(crossover));

% Run GAs
for i = 1:length(crossover)
    for j = 1:numRuns
        [bestInd bestFit] = runGA(@fsphere, nvars, stdev, crossover(i), tournamentSize, popSize, popInitRange, numGenerations, display);
        bestFitnesses(j,i) = bestFit;
    end
end

% Boxplot comparing the best fitnesses
figure;
boxplot(bestFitnesses, 'notch', 'on');
ylabel('Fitness');
